## simdutf 7.5.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15)

project(simdutf
  DESCRIPTION "Fast Unicode validation, transcoding and processing"
  LANGUAGES CXX
  VERSION 7.5.0
)

include (TestBigEndian)
TEST_BIG_ENDIAN(IS_BIG_ENDIAN)
if(IS_BIG_ENDIAN)
  message(STATUS "Big-endian system detected.")
endif()

include(GNUInstallDirs)
# The following requires CMake 3.21.
# if(PROJECT_IS_TOP_LEVEL)
#  message(STATUS "Building simdutf as a top-level project.")
#  include(CTest)
#else()
#  message(STATUS "Building simdutf as a subproject.")
#endif(PROJECT_IS_TOP_LEVEL)
include(CTest)
include(cmake/simdutf-flags.cmake)

set(SIMDUTF_LIB_VERSION "27.0.0" CACHE STRING "simdutf library version")
set(SIMDUTF_LIB_SOVERSION "27" CACHE STRING "simdutf library soversion")
option(SIMDUTF_TESTS "Whether the tests are included as part of the CMake Build." ON)
option(SIMDUTF_ATOMIC_BASE64_TESTS "Whether to test the atomic base64 functions. (OFF by default)" OFF)
option(SIMDUTF_BENCHMARKS "Whether the benchmarks are included as part of the CMake Build." OFF)
option(SIMDUTF_TOOLS "Whether the tools are included as part of the CMake build. Requires C++17 or better." ON)
option(SIMDUTF_ICONV "Whether to use iconv as part of the CMake build if available." ON)
option(SIMDUTF_FUZZERS "Whether to build the fuzzers." OFF)
option(SIMDUTF_COVERAGE "Enable code coverage collection during tests (only GCC and Clang)." OFF)
option(SIMDUTF_INTERNAL_TESTS "Whether to test also internal procedures. Useful mostly for developers, not users." OFF)
option(SIMDUTF_LOGGING "Whether to enable logging (this should never be used in binary releases)." OFF)
option(FUZZING_BUILD_MODE_UNSAFE_FOR_PRODUCTION "Whether to enable unsafe fuzzing mode." OFF)
if(SIMDUTF_LOGGING AND DEFINED CMAKE_CXX_STANDARD AND CMAKE_CXX_STANDARD LESS 17)
    set(CMAKE_CXX_STANDARD 17)
    set(CMAKE_CXX_STANDARD_REQUIRED ON)
endif()
set(SIMDUTF_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR})

add_subdirectory(src)
add_subdirectory(singleheader)

if (SIMDUTF_TESTS)
  message(STATUS "The tests are enabled.")
  add_subdirectory(tests)
else(SIMDUTF_TESTS)
  message(STATUS "The tests are disabled.")
endif(SIMDUTF_TESTS)


if (SIMDUTF_TOOLS)
  if(CMAKE_CXX_COMPILER_ID MATCHES GNU AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS 8.0)
    message(STATUS "The benchmark tool requires GCC 8.0 or better.")
  else()
    add_subdirectory(tools)
  endif()
endif()


if (SIMDUTF_BENCHMARKS)
  if(NOT SIMDUTF_TESTS)
    message(STATUS "You have enabled the benchmarks, but not the tests. We don't allow running the benchmarks without the tests.")
  elseif((CMAKE_CXX_COMPILER_ID MATCHES GNU) AND (CMAKE_CXX_COMPILER_VERSION VERSION_LESS "8.0"))
    message(STATUS "The benchmark tool requires GCC 8.0 or better.")
  else()
    message(STATUS "The benchmarks can be disabled by setting SIMDUTF_BENCHMARKS, e.g., -D SIMDUTF_BENCHMARKS=OFF.")
    add_subdirectory(benchmarks)
  endif()
else()
  message(STATUS "The benchmarks can be enabled by setting SIMDUTF_BENCHMARKS, e.g., -D SIMDUTF_BENCHMARKS=ON.")
endif()

if (SIMDUTF_COVERAGE)
  if (NOT SIMDUTF_TESTS)
    message(FATAL_ERROR "Cannot enable code coverage without tests (enable SIMDUTF_TESTS option)")
  endif()
  if (NOT ((CMAKE_CXX_COMPILER_ID MATCHES "GNU") OR (CMAKE_CXX_COMPILER_ID MATCHES "Clang")))
    message(FATAL_ERROR "Code coverage is supported only by GCC and Clang")
  endif()
  message(STATUS "Code coverage enabled; use `ctest -T Test -T Coverage` to gather coverage details")
endif()

message(STATUS "Compiling using the C++ standard:" ${CMAKE_CXX_STANDARD})
# ---- Install rules ----
add_library(simdutf::simdutf ALIAS simdutf)

set_target_properties(
    simdutf PROPERTIES
    VERSION "${SIMDUTF_LIB_VERSION}"
    SOVERSION "${SIMDUTF_LIB_SOVERSION}"
    WINDOWS_EXPORT_ALL_SYMBOLS YES
)

include(CMakePackageConfigHelpers)
include(GNUInstallDirs)

install(
    FILES include/simdutf.h
    DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}"
    COMPONENT simdutf_Development
)

install(
    DIRECTORY include/simdutf
    DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}"
    COMPONENT simdutf_Development
)

install(
    TARGETS simdutf
    EXPORT simdutfTargets
    RUNTIME COMPONENT simdutf_Runtime
    LIBRARY COMPONENT simdutf_Runtime
    NAMELINK_COMPONENT simdutf_Development
    ARCHIVE COMPONENT simdutf_Development
    INCLUDES DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}"
)

configure_file(cmake/simdutf-config.cmake.in simdutf-config.cmake @ONLY)

write_basic_package_version_file(
    simdutf-config-version.cmake
    COMPATIBILITY SameMinorVersion
)

set(
    SIMDUTF_INSTALL_CMAKEDIR "${CMAKE_INSTALL_LIBDIR}/cmake/simdutf"
    CACHE STRING "CMake package config location relative to the install prefix"
)
mark_as_advanced(SIMDUTF_INSTALL_CMAKEDIR)

install(
    FILES
    "${PROJECT_BINARY_DIR}/simdutf-config.cmake"
    "${PROJECT_BINARY_DIR}/simdutf-config-version.cmake"
    DESTINATION "${SIMDUTF_INSTALL_CMAKEDIR}"
    COMPONENT simdutf_Development
)

install(
    EXPORT simdutfTargets
    NAMESPACE simdutf::
    DESTINATION "${SIMDUTF_INSTALL_CMAKEDIR}"
    COMPONENT example_Development
)


# pkg-config
include(cmake/JoinPaths.cmake)
join_paths(PKGCONFIG_INCLUDEDIR "\${prefix}" "${CMAKE_INSTALL_INCLUDEDIR}")
join_paths(PKGCONFIG_LIBDIR "\${prefix}" "${CMAKE_INSTALL_LIBDIR}")

configure_file("simdutf.pc.in" "simdutf.pc" @ONLY)
install(
    FILES "${CMAKE_CURRENT_BINARY_DIR}/simdutf.pc"
    DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig"
)
#
# CPack
#
if(is_top_project)
  set(CPACK_PACKAGE_VENDOR "Daniel Lemire")
  set(CPACK_PACKAGE_CONTACT "lemire@gmail.com")
  set(CPACK_RESOURCE_FILE_LICENSE "${PROJECT_SOURCE_DIR}/LICENSE-MIT")
  set(CPACK_RPM_PACKAGE_LICENSE "${PROJECT_SOURCE_DIR}/LICENSE-MIT")
  set(CPACK_RESOURCE_FILE_README "${PROJECT_SOURCE_DIR}/README.md")
  set(CPACK_SOURCE_GENERATOR "TGZ;ZIP")
  include(CPack)
endif()

# ----



if(SIMDUTF_TESTS AND NOT SIMDUTF_SANITIZE)
  find_program(GREP grep)
  find_program(NM nm)
  if((NOT GREP) OR (NOT NM))
    message("grep and nm are unavailable on this system.")
  else()
    add_test(
      NAME "avoid_abort"
      # Under FreeBSD, the __cxa_guard_abort symbol may appear but it is fine.
      # So we want to look for <space><possibly _>abort as a test.
      COMMAND sh -c "${NM}  $<TARGET_FILE_NAME:simdutf> |  ${GREP} ' _*abort' || exit 0  && exit 1"
      WORKING_DIRECTORY ${PROJECT_BINARY_DIR}
    )
    add_test(
      NAME "avoid_cout"
      COMMAND sh -c "${NM}  $<TARGET_FILE_NAME:simdutf> |  ${GREP} ' _*cout' || exit 0  && exit 1"
      WORKING_DIRECTORY ${PROJECT_BINARY_DIR}
    )
    add_test(
      NAME "avoid_cerr"
      COMMAND sh -c "${NM}  $<TARGET_FILE_NAME:simdutf> |  ${GREP} ' _*cerr' || exit 0  && exit 1"
      WORKING_DIRECTORY ${PROJECT_BINARY_DIR}
    )
    add_test(
      NAME "avoid_printf"
      COMMAND sh -c "${NM}  $<TARGET_FILE_NAME:simdutf> |  ${GREP} ' _*printf' || exit 0  && exit 1"
      WORKING_DIRECTORY ${PROJECT_BINARY_DIR}
    )
    add_test(
      NAME "avoid_stdout"
      COMMAND sh -c "${NM}  $<TARGET_FILE_NAME:simdutf> |  ${GREP} stdout || exit 0 && exit 1"
      WORKING_DIRECTORY ${PROJECT_BINARY_DIR}
    )
    add_test(
      NAME "avoid_stderr"
      COMMAND sh -c "${NM}  $<TARGET_FILE_NAME:simdutf> |  ${GREP} stderr || exit 0 && exit 1"
      WORKING_DIRECTORY ${PROJECT_BINARY_DIR}
    )
  endif()
endif()

if(SIMDUTF_FUZZERS)
    add_subdirectory(fuzz)
endif()

=== fuzz/CMakeLists.txt ===
# this library provides main() for compilers that do not have libfuzzer (everyone except clang)
# so the source code is compiled regardless of compiler, which prevents code rot.
# also, the library provides a way to invoke the fuzzer on external data which is
# useful to run the fuzz corpus through code also when not using clang.
add_library(main STATIC main.cpp)
target_compile_features(main PRIVATE cxx_std_20)

# see if libfuzzer is supported - this gets more complicated than just checking
# for clang, because apple clang does not seem to support it and windows also
# support clang nowadays (and perhaps libfuzzer)

include(CheckSourceCompiles)
set(CMAKE_REQUIRED_LINK_OPTIONS -fsanitize=fuzzer)
check_source_compiles(CXX "
    #include <cstddef>
    #include <cstdint>
    extern \"C\" int LLVMFuzzerTestOneInput(const uint8_t* Data, size_t Size)
    { return 0;}
    " haslibfuzzer)


macro(create_fuzztest testname)
    add_executable(${testname} ${testname}.cpp)
    target_compile_features(${testname} PRIVATE cxx_std_20)
    target_link_libraries(${testname} PRIVATE simdutf)

    if(haslibfuzzer)
        target_compile_options(${testname} PUBLIC -fsanitize=fuzzer)
        target_link_options(${testname} PUBLIC -fsanitize=fuzzer)
    else()
        # supply a separate main
        target_link_libraries(${testname} PRIVATE main)
    endif()

endmacro()

create_fuzztest(conversion)
create_fuzztest(misc)
if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    # this file uses FuzzedDataProvider.h which is provided by clang
    create_fuzztest(roundtrip)
endif()
create_fuzztest(base64)
create_fuzztest(atomic_base64)

=== scripts/Makefile ===
lint:
	python -m mypy *.py

=== singleheader/CMakeLists.txt ===
#
# Amalgamation
#
set(SINGLEHEADER_FILES
  ${CMAKE_CURRENT_BINARY_DIR}/simdutf.cpp
  ${CMAKE_CURRENT_BINARY_DIR}/simdutf.h
  ${CMAKE_CURRENT_BINARY_DIR}/amalgamation_demo.cpp
  ${CMAKE_CURRENT_BINARY_DIR}/README.md
)
set_source_files_properties(${SINGLEHEADER_FILES} PROPERTIES GENERATED TRUE)

# In theory, this is unneeded, because the tests module does the same test:
find_package (Python3 COMPONENTS Interpreter)

if (Python3_Interpreter_FOUND)
  MESSAGE( STATUS "Python found, we are going to amalgamate.py." )

  add_custom_command(
    OUTPUT ${SINGLEHEADER_FILES}
    COMMAND ${CMAKE_COMMAND} -E env
      AMALGAMATE_SOURCE_PATH=${PROJECT_SOURCE_DIR}/src
      AMALGAMATE_INPUT_PATH=${PROJECT_SOURCE_DIR}/include
      AMALGAMATE_OUTPUT_PATH=${CMAKE_CURRENT_BINARY_DIR}
      ${Python3_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/amalgamate.py
      #
      # This is the best way I could find to make amalgamation trigger whenever source files or
      # header files change: since the "simdutf" library has to get rebuilt when that happens, we
      # take a dependency on the generated library file (even though we're not using it). Depending
      # on simdutf-source doesn't do the trick because DEPENDS here can only depend on an
      # *artifact*--it won't scan source and include files the way a concrete library or executable
      # will.
      #
      # It sucks that we have to build the actual library to make it happen, but it's better than\
      # nothing!
      #
      DEPENDS amalgamate.py simdutf
  )
  add_custom_target(simdutf-singleheader-files DEPENDS ${SINGLEHEADER_FILES})

  #
  # Include this if you intend to #include "simdutf.cpp" in your own .cpp files.
  #
  add_library(simdutf-singleheader-include-source INTERFACE)
  target_include_directories(simdutf-singleheader-include-source INTERFACE $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>)
  add_dependencies(simdutf-singleheader-include-source simdutf-singleheader-files)

  add_library(simdutf-singleheader-source INTERFACE)
  target_sources(simdutf-singleheader-source INTERFACE $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/simdutf.cpp>)
  target_link_libraries(simdutf-singleheader-source INTERFACE simdutf-singleheader-include-source)
  if (SIMDUTF_TESTS)
    add_executable(amalgamation_demo $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/amalgamation_demo.cpp>)
    target_link_libraries(amalgamation_demo simdutf-singleheader-include-source)
    if (CMAKE_CROSSCOMPILING_EMULATOR)
      add_test(amalgamation_demo ${CMAKE_CROSSCOMPILING_EMULATOR} amalgamation_demo)
    else()
      add_test(amalgamation_demo amalgamation_demo)
    endif()
    if(NOT MSVC)
      set_source_files_properties($<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/simdutf.cpp> PROPERTIES COMPILE_OPTIONS "-Wall;-Wextra;-Weffc++;-Wfatal-errors;-Wsign-compare;-Wshadow;-Wwrite-strings;-Wpointer-arith;-Winit-self;-Wconversion;-Wno-sign-conversion;-Wunused-function")
    endif()
  endif()
else()
  MESSAGE( STATUS "Python not found, we are unable to test amalgamate.py." )
endif()

=== src/CMakeLists.txt ===
add_library(simdutf-include-source INTERFACE)
target_include_directories(simdutf-include-source INTERFACE $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>)
add_library(simdutf-source INTERFACE)
target_sources(simdutf-source INTERFACE $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>/simdutf.cpp)
target_link_libraries(simdutf-source INTERFACE simdutf-include-source)
add_library(simdutf simdutf.cpp)
if(WIN32 AND BUILD_SHARED_LIBS)
  target_compile_definitions(
      simdutf
      PRIVATE SIMDUTF_BUILDING_WINDOWS_DYNAMIC_LIBRARY=1
      INTERFACE SIMDUTF_USING_WINDOWS_DYNAMIC_LIBRARY=1
  )
endif()
if(SIMDUTF_LOGGING)
  target_compile_definitions(simdutf PUBLIC SIMDUTF_LOGGING=1)
endif()
if(FUZZING_BUILD_MODE_UNSAFE_FOR_PRODUCTION)
  target_compile_definitions(simdutf PUBLIC FUZZING_BUILD_MODE_UNSAFE_FOR_PRODUCTION=1)
endif()
target_include_directories(simdutf PRIVATE $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}> )
target_include_directories(simdutf PUBLIC "$<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>")
if(NOT DEFINED CMAKE_POSITION_INDEPENDENT_CODE)
  # We default to ON for all targets, so that we can use the library in shared libraries.
  set_target_properties(simdutf PROPERTIES POSITION_INDEPENDENT_CODE ON)
endif(NOT DEFINED CMAKE_POSITION_INDEPENDENT_CODE)
if(MSVC)
  if("${MSVC_TOOLSET_VERSION}" STREQUAL "140")
    target_compile_options(simdutf PRIVATE /W0 /sdl)
    set(SIMDUTF_LEGACY_VISUAL_STUDIO TRUE)
  else()
    target_compile_options(simdutf PRIVATE /WX /W3 /sdl /w34714) # https://docs.microsoft.com/en-us/cpp/error-messages/compiler-warnings/compiler-warning-level-4-c4714?view=vs-2019
  endif()
else(MSVC)
  target_compile_options(simdutf PRIVATE -Wall -Wextra -Weffc++)
  target_compile_options(simdutf PRIVATE -Wsign-compare -Wshadow -Wwrite-strings -Wpointer-arith -Winit-self -Wconversion -Wno-sign-conversion -Wunused-function)
  target_compile_options(simdutf PRIVATE -Wfatal-errors)
endif(MSVC)

if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
    target_compile_options(simdutf PRIVATE -fdiagnostics-color=always)
elseif("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
    target_compile_options(simdutf PRIVATE -fcolor-diagnostics)
endif()

# workaround for GNU GCC poor AVX load/store code generation
if ((CMAKE_CXX_COMPILER_ID STREQUAL "GNU") AND (CMAKE_SYSTEM_PROCESSOR MATCHES "^(i.86|x86(_64)?)$"))
  target_compile_options(simdutf PRIVATE -mno-avx256-split-unaligned-load -mno-avx256-split-unaligned-store)
endif()

if ((CMAKE_CXX_COMPILER_ID STREQUAL "GNU") AND (CMAKE_SYSTEM STREQUAL "PowerPC"))
  target_compile_options(simdutf PRIVATE -maltivec -mvsx -mcpu=power8)
endif()

if(SIMDUTF_ALWAYS_INCLUDE_FALLBACK)
  message(STATUS "SIMDUTF_ALWAYS_INCLUDE_FALLBACK is set to ${SIMDUTF_ALWAYS_INCLUDE_FALLBACK}")
  target_compile_definitions(simdutf PRIVATE SIMDUTF_IMPLEMENTATION_FALLBACK=1)
endif()

if(SIMDUTF_SANITIZE)
  target_compile_options(simdutf PUBLIC -fsanitize=address  -fno-omit-frame-pointer -fno-sanitize-recover=all)
  target_compile_definitions(simdutf PUBLIC ASAN_OPTIONS=detect_leaks=1)
  target_link_libraries(simdutf PUBLIC -fsanitize=address  -fno-omit-frame-pointer -fno-sanitize-recover=all)
endif()
if(SIMDUTF_SANITIZE_UNDEFINED)
  target_compile_options(simdutf PUBLIC -fsanitize=undefined -fno-sanitize-recover=all)
  target_link_libraries(simdutf PUBLIC -fsanitize=undefined)
endif()
if(SIMDUTF_SANITIZE_THREAD)
    target_compile_options(simdutf PUBLIC -fsanitize=thread)
    target_link_libraries(simdutf PUBLIC -fsanitize=thread)
endif()
if(SIMDUTF_INTERNAL_TESTS)
    target_compile_definitions(simdutf PUBLIC SIMDUTF_INTERNAL_TESTS)
endif()
if(WIN32 AND BUILD_SHARED_LIBS)
  set(SIMDUTF_WINDOWS_DLL TRUE)
endif()

=== tests/CMakeLists.txt ===
include(CTest)

set(SIMDUTF_TEST_INCLUDE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/../)
if(MSVC)
  add_compile_options("/Zi" "/EHsc" "/GR")
endif()
add_subdirectory(helpers)
add_subdirectory(reference)

include(${PROJECT_SOURCE_DIR}/cmake/add_cpp_test.cmake)

add_cpp_test(null_safety_tests)
target_link_libraries(null_safety_tests
  PUBLIC simdutf::tests::helpers
         simdutf::tests::reference)

add_cpp_test(readme_tests)
target_link_libraries(readme_tests
  PUBLIC simdutf::tests::helpers
         simdutf::tests::reference)

add_cpp_test(random_fuzzer)
target_link_libraries(random_fuzzer
  PUBLIC simdutf::tests::helpers
         simdutf::tests::reference)
if(WIN32 AND BUILD_SHARED_LIBS)
  # Copy the simdutf dll into the tests directory
  add_custom_command(TARGET random_fuzzer POST_BUILD        # Adds a post-build event
    COMMAND ${CMAKE_COMMAND} -E copy_if_different  # which executes "cmake -E copy_if_different..."
        "$<TARGET_FILE:simdutf>"      # <--this is in-file
        "$<TARGET_FILE_DIR:random_fuzzer>")                 # <--this is out-file path
endif()
add_cpp_test(special_tests)
target_link_libraries(special_tests
  PUBLIC simdutf::tests::helpers
         simdutf::tests::reference)

add_cpp_test(validate_ascii_basic_tests)
target_link_libraries(validate_ascii_basic_tests
  PUBLIC simdutf::tests::helpers
         simdutf::tests::reference)

add_cpp_test(validate_ascii_with_errors_tests)
target_link_libraries(validate_ascii_with_errors_tests
  PUBLIC simdutf::tests::helpers
         simdutf::tests::reference)

add_cpp_test(bele_tests)
target_link_libraries(bele_tests
  PUBLIC simdutf::tests::helpers
         simdutf::tests::reference)

add_cpp_test(validate_utf8_basic_tests)
target_link_libraries(validate_utf8_basic_tests
  PUBLIC simdutf::tests::helpers
         simdutf::tests::reference)


add_cpp_test(select_implementation)
target_link_libraries(select_implementation
  PUBLIC simdutf::tests::helpers
        simdutf::tests::reference)

add_cpp_test(validate_utf8_brute_force_tests)
target_link_libraries(validate_utf8_brute_force_tests
  PUBLIC simdutf::tests::helpers
         simdutf::tests::reference)

add_cpp_test(validate_utf8_puzzler_tests)
target_link_libraries(validate_utf8_puzzler_tests
  PUBLIC simdutf::tests::helpers
         simdutf::tests::reference)

add_cpp_test(validate_utf8_with_errors_tests)
target_link_libraries(validate_utf8_with_errors_tests
  PUBLIC simdutf::tests::helpers
         simdutf::tests::reference)

add_cpp_test(validate_utf16le_basic_tests)
target_link_libraries(validate_utf16le_basic_tests
  PUBLIC simdutf::tests::helpers
         simdutf::tests::reference)

add_cpp_test(validate_utf16be_basic_tests)
target_link_libraries(validate_utf16be_basic_tests
  PUBLIC simdutf::tests::helpers
         simdutf::tests::reference)

add_cpp_test(validate_utf16le_with_errors_tests)
target_link_libraries(validate_utf16le_with_errors_tests
  PUBLIC simdutf::tests::helpers
         simdutf::tests::reference)

add_cpp_test(validate_utf16be_with_errors_tests)
target_link_libraries(validate_utf16be_with_errors_tests
  PUBLIC simdutf::tests::helpers
         simdutf::tests::reference)

add_cpp_test(validate_utf32_basic_tests)
target_link_libraries(validate_utf32_basic_tests
  PUBLIC simdutf::tests::helpers
         simdutf::tests::reference)

add_cpp_test(validate_utf32_with_errors_tests)
target_link_libraries(validate_utf32_with_errors_tests
  PUBLIC simdutf::tests::helpers
         simdutf::tests::reference)

find_package(Python3 COMPONENTS Interpreter)
if(Python3_FOUND)
  set(SCRIPT ${SIMDUTF_SOURCE_DIR}/scripts/sse_validate_utf16le_testcases.py)
  add_custom_command(TARGET validate_utf16le_basic_tests
                   COMMAND ${Python3_EXECUTABLE} ${SCRIPT}
                   POST_BUILD
                   VERBATIM
  )
  unset(SCRIPT)
endif(Python3_FOUND)
add_cpp_test(find_tests)

target_link_libraries(find_tests
  PUBLIC simdutf::tests::helpers
         simdutf::tests::reference)

add_cpp_test(convert_latin1_to_utf8_tests)
target_link_libraries(convert_latin1_to_utf8_tests 
  PUBLIC simdutf::tests::helpers
         simdutf::tests::reference)

add_cpp_test(convert_latin1_to_utf16le_tests)
target_link_libraries(convert_latin1_to_utf16le_tests
  PUBLIC simdutf::tests::helpers
         simdutf::tests::reference)

add_cpp_test(convert_latin1_to_utf16be_tests)
target_link_libraries(convert_latin1_to_utf16be_tests
  PUBLIC simdutf::tests::helpers
         simdutf::tests::reference)

add_cpp_test(convert_latin1_to_utf32_tests)
target_link_libraries(convert_latin1_to_utf32_tests 
    PUBLIC simdutf::tests::helpers
      simdutf::tests::reference)

add_cpp_test(convert_utf8_to_latin1_tests)
target_link_libraries(convert_utf8_to_latin1_tests 
  PUBLIC simdutf::tests::helpers
        simdutf::tests::reference)

add_cpp_test(convert_utf8_to_latin1_with_errors_tests)
target_link_libraries(convert_utf8_to_latin1_with_errors_tests 
  PUBLIC simdutf::tests::helpers
          simdutf::tests::reference)
        
add_cpp_test(convert_valid_utf8_to_latin1_tests)
target_link_libraries(convert_valid_utf8_to_latin1_tests 
  PUBLIC simdutf::tests::helpers
        simdutf::tests::reference)
         
add_cpp_test(convert_valid_utf8_to_utf16le_tests)
target_link_libraries(convert_valid_utf8_to_utf16le_tests
  PUBLIC simdutf::tests::helpers
         simdutf::tests::reference)

add_cpp_test(convert_valid_utf8_to_utf16be_tests)
target_link_libraries(convert_valid_utf8_to_utf16be_tests
  PUBLIC simdutf::tests::helpers
         simdutf::tests::reference)

add_cpp_test(convert_valid_utf8_to_utf32_tests)
target_link_libraries(convert_valid_utf8_to_utf32_tests
  PUBLIC simdutf::tests::helpers
         simdutf::tests::reference)

add_cpp_test(convert_utf8_to_utf16le_tests)
target_link_libraries(convert_utf8_to_utf16le_tests
  PUBLIC simdutf::tests::helpers
         simdutf::tests::reference)

add_cpp_test(convert_utf8_to_utf16be_tests)
target_link_libraries(convert_utf8_to_utf16be_tests
  PUBLIC simdutf::tests::helpers
         simdutf::tests::reference)

add_cpp_test(convert_utf8_to_utf16le_with_errors_tests)
target_link_libraries(convert_utf8_to_utf16le_with_errors_tests
  PUBLIC simdutf::tests::helpers
         simdutf::tests::reference)

add_cpp_test(convert_utf8_to_utf16be_with_errors_tests)
target_link_libraries(convert_utf8_to_utf16be_with_errors_tests
  PUBLIC simdutf::tests::helpers
         simdutf::tests::reference)

add_cpp_test(convert_utf8_to_utf32_tests)
target_link_libraries(convert_utf8_to_utf32_tests
  PUBLIC simdutf::tests::helpers
         simdutf::tests::reference)

add_cpp_test(convert_utf8_to_utf32_with_errors_tests)
target_link_libraries(convert_utf8_to_utf32_with_errors_tests
  PUBLIC simdutf::tests::helpers
         simdutf::tests::reference)

add_cpp_test(convert_utf16le_to_latin1_tests)
target_link_libraries(convert_utf16le_to_latin1_tests 
  PUBLIC simdutf::tests::helpers
          simdutf::tests::reference)

add_cpp_test(convert_utf16be_to_latin1_tests)
target_link_libraries(convert_utf16be_to_latin1_tests 
  PUBLIC simdutf::tests::helpers
          simdutf::tests::reference)

add_cpp_test(convert_utf16le_to_latin1_tests_with_errors)
target_link_libraries(convert_utf16le_to_latin1_tests_with_errors 
  PUBLIC simdutf::tests::helpers
          simdutf::tests::reference)

add_cpp_test(convert_utf16be_to_latin1_tests_with_errors)
target_link_libraries(convert_utf16be_to_latin1_tests_with_errors 
  PUBLIC simdutf::tests::helpers
          simdutf::tests::reference)

add_cpp_test(convert_valid_utf16le_to_latin1_tests)
target_link_libraries(convert_valid_utf16le_to_latin1_tests 
  PUBLIC simdutf::tests::helpers
          simdutf::tests::reference)

add_cpp_test(convert_valid_utf16be_to_latin1_tests)
target_link_libraries(convert_valid_utf16be_to_latin1_tests 
  PUBLIC simdutf::tests::helpers
          simdutf::tests::reference)

add_cpp_test(convert_utf16_to_utf8_safe_tests)
target_link_libraries(convert_utf16_to_utf8_safe_tests
  PUBLIC simdutf::tests::helpers
         simdutf::tests::reference)

add_cpp_test(convert_utf16le_to_utf8_tests)
target_link_libraries(convert_utf16le_to_utf8_tests
  PUBLIC simdutf::tests::helpers
         simdutf::tests::reference)

add_cpp_test(convert_utf16be_to_utf8_tests)
target_link_libraries(convert_utf16be_to_utf8_tests
  PUBLIC simdutf::tests::helpers
         simdutf::tests::reference)

add_cpp_test(convert_utf16le_to_utf8_with_errors_tests)
target_link_libraries(convert_utf16le_to_utf8_with_errors_tests
  PUBLIC simdutf::tests::helpers
         simdutf::tests::reference)

add_cpp_test(convert_utf16be_to_utf8_with_errors_tests)
target_link_libraries(convert_utf16be_to_utf8_with_errors_tests
  PUBLIC simdutf::tests::helpers
         simdutf::tests::reference)
        
add_cpp_test(convert_utf32_to_latin1_tests)
target_link_libraries(convert_utf32_to_latin1_tests 
  PUBLIC simdutf::tests::helpers
        simdutf::tests::reference)

add_cpp_test(convert_valid_utf32_to_latin1_tests)
target_link_libraries(convert_valid_utf32_to_latin1_tests 
  PUBLIC simdutf::tests::helpers
        simdutf::tests::reference)

add_cpp_test(convert_utf32_to_latin1_with_errors_tests)
target_link_libraries(convert_utf32_to_latin1_with_errors_tests 
  PUBLIC simdutf::tests::helpers
        simdutf::tests::reference)         
          
add_cpp_test(convert_utf32_to_utf8_tests)
target_link_libraries(convert_utf32_to_utf8_tests
  PUBLIC simdutf::tests::helpers
         simdutf::tests::reference)

add_cpp_test(convert_utf32_to_utf8_with_errors_tests)
target_link_libraries(convert_utf32_to_utf8_with_errors_tests
  PUBLIC simdutf::tests::helpers
         simdutf::tests::reference)

add_cpp_test(convert_utf32_to_utf16le_tests)
target_link_libraries(convert_utf32_to_utf16le_tests
  PUBLIC simdutf::tests::helpers
         simdutf::tests::reference)

add_cpp_test(convert_utf32_to_utf16be_tests)
target_link_libraries(convert_utf32_to_utf16be_tests
  PUBLIC simdutf::tests::helpers
         simdutf::tests::reference)

add_cpp_test(convert_utf32_to_utf16le_with_errors_tests)
target_link_libraries(convert_utf32_to_utf16le_with_errors_tests
  PUBLIC simdutf::tests::helpers
         simdutf::tests::reference)

add_cpp_test(convert_utf32_to_utf16be_with_errors_tests)
target_link_libraries(convert_utf32_to_utf16be_with_errors_tests
  PUBLIC simdutf::tests::helpers
         simdutf::tests::reference)

add_cpp_test(convert_valid_utf16le_to_utf8_tests)
target_link_libraries(convert_valid_utf16le_to_utf8_tests
  PUBLIC simdutf::tests::helpers
         simdutf::tests::reference)

add_cpp_test(convert_valid_utf16be_to_utf8_tests)
target_link_libraries(convert_valid_utf16be_to_utf8_tests
  PUBLIC simdutf::tests::helpers
         simdutf::tests::reference)

add_cpp_test(convert_valid_utf32_to_utf8_tests)
target_link_libraries(convert_valid_utf32_to_utf8_tests
  PUBLIC simdutf::tests::helpers
         simdutf::tests::reference)

add_cpp_test(convert_valid_utf32_to_utf16le_tests)
target_link_libraries(convert_valid_utf32_to_utf16le_tests
  PUBLIC simdutf::tests::helpers
         simdutf::tests::reference)

add_cpp_test(convert_valid_utf32_to_utf16be_tests)
target_link_libraries(convert_valid_utf32_to_utf16be_tests
  PUBLIC simdutf::tests::helpers
         simdutf::tests::reference)

add_cpp_test(convert_utf16le_to_utf32_tests)
target_link_libraries(convert_utf16le_to_utf32_tests
  PUBLIC simdutf::tests::helpers
         simdutf::tests::reference)

add_cpp_test(convert_utf16be_to_utf32_tests)
target_link_libraries(convert_utf16be_to_utf32_tests
  PUBLIC simdutf::tests::helpers
         simdutf::tests::reference)

add_cpp_test(convert_utf16le_to_utf32_with_errors_tests)
target_link_libraries(convert_utf16le_to_utf32_with_errors_tests
  PUBLIC simdutf::tests::helpers
         simdutf::tests::reference)

add_cpp_test(convert_utf16be_to_utf32_with_errors_tests)
target_link_libraries(convert_utf16be_to_utf32_with_errors_tests
  PUBLIC simdutf::tests::helpers

=== tools/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15)

add_executable(sutf sutf.cpp)
add_executable(fastbase64 fastbase64.cpp)

if(SIMDUTF_ICONV)
find_package(Iconv)
if(Iconv_FOUND)
  message(STATUS "Iconv was found!")
  target_compile_definitions(sutf PRIVATE ICONV_AVAILABLE=1)
  if(Iconv_IS_BUILT_IN)
    message(STATUS "Iconv is part of the C library.")
  else(Iconv_IS_BUILT_IN)
    message(STATUS "Iconv is a separate library, headers at ${Iconv_INCLUDE_DIR}, binary at ${Iconv_LIBRARY}")
    target_link_libraries(sutf PUBLIC ${Iconv_LIBRARY})
    target_include_directories(sutf PUBLIC ${Iconv_INCLUDE_DIR})
  endif(Iconv_IS_BUILT_IN)
else(Iconv_FOUND)
  message(STATUS "Iconv was not found!")
endif(Iconv_FOUND)
else(SIMDUTF_ICONV)
  message(STATUS "We are not seeking iconv.")
endif(SIMDUTF_ICONV)
if(APPLE)
  message(STATUS "This is an Apple platform " ${CMAKE_CXX_COMPILER_ID})

  if(CMAKE_CXX_COMPILER_ID STREQUAL "AppleClang" OR CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
    message(STATUS "Apple platform detected, using dead_strip and LTO")
    target_link_options(sutf PRIVATE "-Wl,-dead_strip")
    target_link_options(fastbase64 PRIVATE "-Wl,-dead_strip")
    target_compile_options(sutf PRIVATE "-flto")
    target_link_options(sutf PRIVATE "-flto")
    target_compile_options(fastbase64 PRIVATE "-flto")
    target_link_options(fastbase64 PRIVATE "-flto")
  endif()
endif()

if((CMAKE_CXX_COMPILER_ID STREQUAL "GNU") OR (CMAKE_CXX_COMPILER_ID STREQUAL "Clang"))
  execute_process(COMMAND ${CMAKE_CXX_COMPILER} -print-libgcc-file-name OUTPUT_VARIABLE SIMDUTF_GCC_LIB)
  get_filename_component(SIMDUTF_GCC_DIR "${SIMDUTF_GCC_LIB}" DIRECTORY)
  message(STATUS "looking for static C++ library in " ${SIMDUTF_GCC_DIR})
  find_library(LIBSTDCPP libstdc++.a PATHS "${SIMDUTF_GCC_DIR}")
  if(LIBSTDCPP)
    message(STATUS "libstdc++.a found")
    target_link_options(sutf PRIVATE "-static-libstdc++")
    target_link_options(fastbase64 PRIVATE "-static-libstdc++")
  else()
    message(STATUS "libstdc++.a not found")
  endif()
  if(NOT APPLE)
    target_link_options(sutf PRIVATE "-Wl,--gc-sections")
    target_link_options(fastbase64 PRIVATE "-Wl,--gc-sections")
  endif()
endif()
message(STATUS "The tools require C++17. If your system does not support C++17, please set SIMDUTF_TOOLS to OFF.")
set_property(TARGET sutf PROPERTY CXX_STANDARD 17)
set_property(TARGET sutf PROPERTY CXX_STANDARD_REQUIRED ON)
set_property(TARGET fastbase64 PROPERTY CXX_STANDARD 17)
set_property(TARGET fastbase64 PROPERTY CXX_STANDARD_REQUIRED ON)

target_link_libraries(sutf PUBLIC simdutf)
target_link_libraries(fastbase64 PUBLIC simdutf)

if(WIN32 AND BUILD_SHARED_LIBS)
  # Copy the simdutf dll into the directory
  add_custom_command(TARGET sutf POST_BUILD        # Adds a post-build event
    COMMAND ${CMAKE_COMMAND} -E copy_if_different  # which executes "cmake -E copy_if_different..."
        "$<TARGET_FILE:simdutf>"      # <--this is in-file
        "$<TARGET_FILE_DIR:sutf>")                 # <--this is out-file path
endif()
install(
   TARGETS
    sutf
   ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
   LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
   RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
)

install(
   TARGETS
    fastbase64
   ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
   LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
   RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
)

=== scripts/docker/Makefile ===
# ideally I would like to upload this to the simdutf package registry but
# I think my privs need to be higher for that to work.

# clang format 18
.PHONY: build-18 publish-18
build-18:
	docker build --build-arg CLANGVERSION=18 --tag ghcr.io/pauldreik/clang-format-18:latest .
publish-18: build-18
	docker push ghcr.io/pauldreik/clang-format-18:latest

=== tests/installation_tests/find/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15)

project(test_simdutf_install VERSION 0.1.0 LANGUAGES CXX)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
if(MSVC_VERSION GREATER 1910)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -permissive-")
endif()
find_package(simdutf REQUIRED)



file(WRITE main.cpp "
#include <iostream>
#include \"simdutf.h\"

int main(int argc, char *argv[]) {
   const char * ascii = \"1234\";
   bool validutf8 = simdutf::validate_utf8(ascii, 4);
   if(validutf8) {
       std::cout << \"valid UTF-8\" << std::endl;
   } else {
       std::cout << \"invalid UTF-8\" << std::endl;
       return EXIT_FAILURE;
   }
   char16_t utf16_output[4];
   // convert to UTF-16LE
   size_t utf16words = simdutf::convert_utf8_to_utf16le(ascii, 4, utf16_output);
   std::cout << \"wrote \" << utf16words << \" UTF-16 code units.\" << std::endl;
   // It wrote utf16words * sizeof(char16_t) bytes.
   //
   // convert it back:
   char buffer[4];
   size_t utf8words = simdutf::convert_utf16le_to_utf8(utf16_output, utf16words, buffer);
   std::cout << \"wrote \" << utf8words << \" UTF-8 code units.\" << std::endl;
   return EXIT_SUCCESS;
}")



add_executable(repro main.cpp)
target_link_libraries(repro PUBLIC simdutf::simdutf)

=== tests/installation_tests/from_fetch/CMakeLists.txt ===

cmake_minimum_required(VERSION 3.15)

project(simdutf_demo_install VERSION 0.1.0 LANGUAGES CXX)


set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
include(FetchContent)

FetchContent_Declare(
  simdutf
  GIT_REPOSITORY git@github.com:simdutf/simdutf.git
  GIT_SHALLOW TRUE
  GIT_TAG tags/v3.2.7
  )
FetchContent_MakeAvailable(simdutf)

file(WRITE main.cpp "
#include <iostream>
#include \"simdutf.h\"
int main(int argc, char *argv[]) {
   const char * ascii = \"1234\";
   bool validutf8 = simdutf::validate_utf8(ascii, 4);
   if(validutf8) {
       std::cout << \"valid UTF-8\" << std::endl;
   } else {
       std::cout << \"invalid UTF-8\" << std::endl;
       return EXIT_FAILURE;
   }
   char16_t utf16_output[4];
   // convert to UTF-16LE
   size_t utf16words = simdutf::convert_utf8_to_utf16le(ascii, 4, utf16_output);
   std::cout << \"wrote \" << utf16words << \" UTF-16 code units.\" << std::endl;
   // It wrote utf16words * sizeof(char16_t) bytes.
   //
   // convert it back:
   char buffer[4];
   size_t utf8words = simdutf::convert_utf16le_to_utf8(utf16_output, utf16words, buffer);
   std::cout << \"wrote \" << utf8words << \" UTF-8 code units.\" << std::endl;
   return EXIT_SUCCESS;
}")



add_executable(repro main.cpp)
target_link_libraries(repro PUBLIC simdutf::simdutf)

=== debian/changelog ===
simdutf (7.5.0-2) unstable; urgency=medium

  * Release to unstable

 -- Jeremy Bícha <jbicha@ubuntu.com>  Sun, 19 Oct 2025 14:11:57 -0400

simdutf (7.5.0-1) experimental; urgency=medium

  * New upstream release

 -- Jeremy Bícha <jbicha@ubuntu.com>  Sat, 18 Oct 2025 08:11:02 -0400

=== debian/control ===
Source: simdutf
Section: libs
Homepage: https://github.com/simdutf/simdutf
Priority: optional
Standards-Version: 4.7.2
Vcs-Git: https://salsa.debian.org/debian/simdutf.git
Vcs-Browser: https://salsa.debian.org/debian/simdutf
Maintainer: Mo Zhou <lumin@debian.org>
Uploaders: Jeremy Bícha <jbicha@ubuntu.com>
Build-Depends: debhelper-compat (= 13), cmake, python3,

Package: libsimdutf-dev
Architecture: any
Section: libdevel
Depends: libsimdutf27 (= ${binary:Version}),
	 ${misc:Depends}
Description: Fast Unicode validation and transcoding - development files
 Most modern software relies on the Unicode standard. In memory, Unicode
 strings are represented using either UTF-8 or UTF-16. The UTF-8 format is the
 de facto standard on the web (JSON, HTML, etc.) and it has been adopted as the
 default in many popular programming languages (Go, Zig, Rust, Swift, etc.).
 The UTF-16 format is standard in Java, C# and in many Windows technologies.
 .
 Not all sequences of bytes are valid Unicode strings. It is unsafe to use
 Unicode strings in UTF-8 and UTF-16LE without first validating them.
 Furthermore, we often need to convert strings from one encoding to another, by
 a process called transcoding. For security purposes, such transcoding should
 be validating: it should refuse to transcode incorrect strings.
 .
 This library provide fast Unicode functions such as
 .
  * ASCII, UTF-8, UTF-16LE/BE and UTF-32 validation, with and without error
    identification,
  * Latin1 to UTF-8 transcoding,
  * Latin1 to UTF-16LE/BE transcoding
  * Latin1 to UTF-32 transcoding
  * UTF-8 to Latin1 transcoding, with or without validation, with and without
    error identification,
  * UTF-8 to UTF-16LE/BE transcoding, with or without validation, with and
    without error identification,
  * UTF-8 to UTF-32 transcoding, with or without validation, with and without
    error identification,
  * UTF-16LE/BE to Latin1 transcoding, with or without validation, with and
    without error identification,
  * UTF-16LE/BE to UTF-8 transcoding, with or without validation, with and
    without error identification,
  * UTF-32 to Latin1 transcoding, with or without validation, with and without
    error identification,
  * UTF-32 to UTF-8 transcoding, with or without validation, with and without
    error identification,
  * UTF-32 to UTF-16LE/BE transcoding, with or without validation, with and
    without error identification,
  * UTF-16LE/BE to UTF-32 transcoding, with or without validation, with and
    without error identification,
  * From an UTF-8 string, compute the size of the Latin1 equivalent string,
  * From an UTF-8 string, compute the size of the UTF-16 equivalent string,
  * From an UTF-8 string, compute the size of the UTF-32 equivalent string
    (equivalent to UTF-8 character counting),
  * From an UTF-16LE/BE string, compute the size of the Latin1 equivalent
    string,
  * From an UTF-16LE/BE string, compute the size of the UTF-8 equivalent
    string,
  * From an UTF-32 string, compute the size of the UTF-8 or UTF-16LE equivalent
    string,
  * From an UTF-16LE/BE string, compute the size of the UTF-32 equivalent
    string (equivalent to UTF-16 character counting),
  * UTF-8 and UTF-16LE/BE character counting,
  * UTF-16 endianness change (UTF16-LE/BE to UTF-16-BE/LE),
  * WHATWG forgiving-base64 (with or without URL encoding) to binary,
  * Binary to base64 (with or without URL encoding).
 .
 The functions are accelerated using SIMD instructions (e.g., ARM NEON, SSE,
 AVX, AVX-512, RISC-V Vector Extension, LoongSon, POWER, etc.). When your
 strings contain hundreds of characters, we can often transcode them at speeds
 exceeding a billion characters per second. You should expect high speeds not
 only with English strings (ASCII) but also Chinese, Japanese, Arabic, and so
 forth. We handle the full character range (including, for example, emojis).
 .
 The library compiles down to a small library of a few hundred kilobytes. Our
 functions are exception-free and non allocating. We have extensive tests and
 extensive benchmarks.
 .
 This package ships the development files.

Package: libsimdutf27
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Fast Unicode validation and transcoding
 Most modern software relies on the Unicode standard. In memory, Unicode
 strings are represented using either UTF-8 or UTF-16. The UTF-8 format is the
 de facto standard on the web (JSON, HTML, etc.) and it has been adopted as the
 default in many popular programming languages (Go, Zig, Rust, Swift, etc.).
 The UTF-16 format is standard in Java, C# and in many Windows technologies.
 .
 Not all sequences of bytes are valid Unicode strings. It is unsafe to use
 Unicode strings in UTF-8 and UTF-16LE without first validating them.
 Furthermore, we often need to convert strings from one encoding to another, by
 a process called transcoding. For security purposes, such transcoding should
 be validating: it should refuse to transcode incorrect strings.
 .
 This library provide fast Unicode functions such as
 .
  * ASCII, UTF-8, UTF-16LE/BE and UTF-32 validation, with and without error
    identification,
  * Latin1 to UTF-8 transcoding,
  * Latin1 to UTF-16LE/BE transcoding
  * Latin1 to UTF-32 transcoding
  * UTF-8 to Latin1 transcoding, with or without validation, with and without
    error identification,
  * UTF-8 to UTF-16LE/BE transcoding, with or without validation, with and
    without error identification,
  * UTF-8 to UTF-32 transcoding, with or without validation, with and without
    error identification,
  * UTF-16LE/BE to Latin1 transcoding, with or without validation, with and
    without error identification,
  * UTF-16LE/BE to UTF-8 transcoding, with or without validation, with and
    without error identification,
  * UTF-32 to Latin1 transcoding, with or without validation, with and without
    error identification,
  * UTF-32 to UTF-8 transcoding, with or without validation, with and without
    error identification,
  * UTF-32 to UTF-16LE/BE transcoding, with or without validation, with and
    without error identification,
  * UTF-16LE/BE to UTF-32 transcoding, with or without validation, with and
    without error identification,
  * From an UTF-8 string, compute the size of the Latin1 equivalent string,
  * From an UTF-8 string, compute the size of the UTF-16 equivalent string,
  * From an UTF-8 string, compute the size of the UTF-32 equivalent string
    (equivalent to UTF-8 character counting),
  * From an UTF-16LE/BE string, compute the size of the Latin1 equivalent
    string,
  * From an UTF-16LE/BE string, compute the size of the UTF-8 equivalent
    string,
  * From an UTF-32 string, compute the size of the UTF-8 or UTF-16LE equivalent
    string,
  * From an UTF-16LE/BE string, compute the size of the UTF-32 equivalent
    string (equivalent to UTF-16 character counting),
  * UTF-8 and UTF-16LE/BE character counting,
  * UTF-16 endianness change (UTF16-LE/BE to UTF-16-BE/LE),
  * WHATWG forgiving-base64 (with or without URL encoding) to binary,
  * Binary to base64 (with or without URL encoding).
 .
 The functions are accelerated using SIMD instructions (e.g., ARM NEON, SSE,
 AVX, AVX-512, RISC-V Vector Extension, LoongSon, POWER, etc.). When your
 strings contain hundreds of characters, we can often transcode them at speeds
 exceeding a billion characters per second. You should expect high speeds not
 only with English strings (ASCII) but also Chinese, Japanese, Arabic, and so
 forth. We handle the full character range (including, for example, emojis).
 .
 The library compiles down to a small library of a few hundred kilobytes. Our
 functions are exception-free and non allocating. We have extensive tests and
 extensive benchmarks.
 .
 This package ships the shared object.

Package: libsimdutf-tools
Architecture: any
Section: misc
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Fast Unicode validation and transcoding - utilities
 Most modern software relies on the Unicode standard. In memory, Unicode
 strings are represented using either UTF-8 or UTF-16. The UTF-8 format is the
 de facto standard on the web (JSON, HTML, etc.) and it has been adopted as the
 default in many popular programming languages (Go, Zig, Rust, Swift, etc.).
 The UTF-16 format is standard in Java, C# and in many Windows technologies.
 .
 Not all sequences of bytes are valid Unicode strings. It is unsafe to use
 Unicode strings in UTF-8 and UTF-16LE without first validating them.
 Furthermore, we often need to convert strings from one encoding to another, by
 a process called transcoding. For security purposes, such transcoding should
 be validating: it should refuse to transcode incorrect strings.
 .
 This library provide fast Unicode functions such as
 .
  * ASCII, UTF-8, UTF-16LE/BE and UTF-32 validation, with and without error
    identification,
  * Latin1 to UTF-8 transcoding,
  * Latin1 to UTF-16LE/BE transcoding
  * Latin1 to UTF-32 transcoding
  * UTF-8 to Latin1 transcoding, with or without validation, with and without
    error identification,
  * UTF-8 to UTF-16LE/BE transcoding, with or without validation, with and
    without error identification,
  * UTF-8 to UTF-32 transcoding, with or without validation, with and without
    error identification,
  * UTF-16LE/BE to Latin1 transcoding, with or without validation, with and
    without error identification,
  * UTF-16LE/BE to UTF-8 transcoding, with or without validation, with and
    without error identification,
  * UTF-32 to Latin1 transcoding, with or without validation, with and without
    error identification,
  * UTF-32 to UTF-8 transcoding, with or without validation, with and without
    error identification,
  * UTF-32 to UTF-16LE/BE transcoding, with or without validation, with and
    without error identification,
  * UTF-16LE/BE to UTF-32 transcoding, with or without validation, with and
    without error identification,
  * From an UTF-8 string, compute the size of the Latin1 equivalent string,
  * From an UTF-8 string, compute the size of the UTF-16 equivalent string,
  * From an UTF-8 string, compute the size of the UTF-32 equivalent string
    (equivalent to UTF-8 character counting),
  * From an UTF-16LE/BE string, compute the size of the Latin1 equivalent
    string,
  * From an UTF-16LE/BE string, compute the size of the UTF-8 equivalent
    string,
  * From an UTF-32 string, compute the size of the UTF-8 or UTF-16LE equivalent
    string,
  * From an UTF-16LE/BE string, compute the size of the UTF-32 equivalent
    string (equivalent to UTF-16 character counting),
  * UTF-8 and UTF-16LE/BE character counting,
  * UTF-16 endianness change (UTF16-LE/BE to UTF-16-BE/LE),
  * WHATWG forgiving-base64 (with or without URL encoding) to binary,
  * Binary to base64 (with or without URL encoding).
 .
 The functions are accelerated using SIMD instructions (e.g., ARM NEON, SSE,
 AVX, AVX-512, RISC-V Vector Extension, LoongSon, POWER, etc.). When your
 strings contain hundreds of characters, we can often transcode them at speeds
 exceeding a billion characters per second. You should expect high speeds not
 only with English strings (ASCII) but also Chinese, Japanese, Arabic, and so
 forth. We handle the full character range (including, for example, emojis).
 .
 The library compiles down to a small library of a few hundred kilobytes. Our
 functions are exception-free and non allocating. We have extensive tests and
 extensive benchmarks.
 .
 This package ships several command line tools.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_SHARED_LIBS=ON
